---
title: GeneratorFunction
slug: Web/JavaScript/Reference/Global_Objects/GeneratorFunction
tags:
  - Constructor
  - ECMAScript 2015
  - GeneratorFunction
  - Iterator
  - JavaScript
  - Reference
---
<div>{{JSRef}}</div>

<p>The <strong><code>GeneratorFunction</code> constructor</strong> creates a new {{jsxref("Statements/function*", "generator function", "", 1)}} object. In JavaScript, every generator function is actually a <code>GeneratorFunction</code> object.</p>

<p>Note that <code>GeneratorFunction</code> is not a global object. It could be obtained by evaluating the following code.</p>

<pre class="brush: js">Object.getPrototypeOf(function*(){}).constructor
</pre>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">new GeneratorFunction ([<var>arg1</var>[, <var>arg2</var>[, ...<var>argN</var>]],] <var>functionBody</var>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>arg1, arg2, ... arg<em>N</em></code></dt>
 <dd>Names to be used by the function as formal argument names. Each must be a string that corresponds to a valid JavaScript identifier or a list of such strings separated with a comma; for example "<code>x</code>", "<code>theValue</code>", or "<code>a,b</code>".</dd>
 <dt><code>functionBody</code></dt>
 <dd>A string containing the JavaScript statements comprising the function definition.</dd>
</dl>

<h2 id="Description">Description</h2>

<p>{{jsxref("Statements/function*", "generator function")}} objects created with the <code>GeneratorFunction</code> constructor are parsed when the function is created. This is less efficient than declaring a generator function with a {{jsxref("Statements/function*", "function* expression")}} and calling it within your code, because such functions are parsed with the rest of the code.</p>

<p>All arguments passed to the function are treated as the names of the identifiers of the parameters in the function to be created, in the order in which they are passed.</p>

<div class="note">
<p><strong>Note:</strong> {{jsxref("Statements/function*", "generator function")}} created with the <code>GeneratorFunction</code> constructor do not create closures to their creation contexts; they are always created in the global scope.</p>

<p>When running them, they will only be able to access their own local variables and global ones, not the ones from the scope in which the <code>GeneratorFunction</code> constructor was called.</p>

<p>This is different from using {{jsxref("Global_Objects/eval", "eval")}} with code for a generator function expression.</p>
</div>

<p>Invoking the <code>GeneratorFunction</code> constructor as a function (without using the <code>new</code> operator) has the same effect as invoking it as a constructor.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Creating_a_generator_function_from_a_GeneratorFunction_constructor">Creating a generator function from a GeneratorFunction() constructor</h3>

<pre class="brush: js">var GeneratorFunction = Object.getPrototypeOf(function*(){}).constructor
var g = new GeneratorFunction('a', 'yield a * 2');
var iterator = g(10);
console.log(iterator.next().value); // 20
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-generatorfunction-objects', 'GeneratorFunction')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.GeneratorFunction")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Statements/function*", "function* function", "", 1)}}</li>
 <li>{{jsxref("Operators/function*", "function* expression", "", 1)}}</li>
 <li>{{jsxref("Global_Objects/Function", "Function")}}</li>
 <li>{{jsxref("Statements/function", "function statement", "", 1)}}</li>
 <li>{{jsxref("Operators/function", "function expression", "", 1)}}</li>
 <li>{{jsxref("Functions_and_function_scope", "Functions and function scope", "", 1)}}</li>
</ul>
